Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Static_Allocator_Base Class Reference

Defines a class that provided a highly optimized memory management scheme for allocating memory statically. More...

`#include <Malloc_Allocator.h>`

Inheritance diagram for ACE_Static_Allocator_Base:

[legend]
Collaboration diagram for ACE_Static_Allocator_Base:

[legend]
List of all members.

## Public Methods
| ACE_Static_Allocator_Base (char *buffer, size_t size)
virtual void * | malloc (size_t nbytes)
| Allocate <nbytes>, but don't give them any initial value. More...
virtual void * | calloc (size_t nbytes, char initial_value='\0')
| Allocate <nbytes>, giving them <initial_value>. More...
virtual void * | calloc (size_t n_elem, size_t elem_size, char initial_value='\0')
| Allocate <n_elem> each of size <elem_size>, giving them <initial_value>. More...
virtual void | free (void *ptr)
| Free <ptr> (must have been allocated by <ACE_Allocator::malloc>). More...
virtual int | remove (void)
| Remove any resources associated with this memory manager. More...
virtual int | bind (const char *name, void *pointer, int duplicates=0)
| Associate <name> with <pointer>. More...
virtual int | trybind (const char *name, void *&pointer)
| Associate <name> with <pointer>. More...
virtual int | find (const char *name, void *&pointer)
| Locate <name> and pass out parameter via pointer. If found, return 0, returns -1 if failure occurs. More...
virtual int | find (const char *name)
| Returns 0 if the name is in the mapping. -1, otherwise. More...
virtual int | unbind (const char *name)
| Unbind (remove) the name from the map. Don't return the pointer to the caller. More...
virtual int | unbind (const char *name, void *&pointer)
| Break any association of name. Returns the value of pointer in case the caller needs to deallocate memory. More...
virtual int | sync (ssize_t len=-1, int flags=MS_SYNC)
| Sync <len> bytes of the memory region to the backing store starting at <this->base_addr_>. More...
virtual int | sync (void *addr, size_t len, int flags=MS_SYNC)
| Sync <len> bytes of the memory region to the backing store starting at <addr_>. More...
virtual int | protect (ssize_t len=-1, int prot=PROT_RDWR)
| Change the protection of the pages of the mapped region to <prot> starting at <this->base_addr_> up to <len> bytes. More...
virtual int | protect (void *addr, size_t len, int prot=PROT_RDWR)
| Change the protection of the pages of the mapped region to <prot> starting at <addr> up to <len> bytes. More...
virtual void | dump (void) const
| Dump the state of the object. More...
## Protected Methods
| ACE_Static_Allocator_Base (void)
| Don't allow direct instantiations of this class. More...
## Protected Attributes
char * | buffer_
| Pointer to the buffer. More...
size_t | size_
| Size of the buffer. More...
size_t | offset_
| Pointer to the current offset in the <buffer_>. More...

## Detailed Description

Defines a class that provided a highly optimized memory management scheme for allocating memory statically.

This class manages a fixed-size <POOL_SIZE> of memory. Every time <malloc>/<calloc> is called, it simply moves an internal index forward and returns a pointer to the requested chunk. All memory is allocated statically (typically via the <ACE_Static_Allocator> template) and <free> is a no-op. This behavior is useful for use-cases where all the memory allocation needs are known in advance and no deletions ever occur.

## Constructor & Destructor Documentation

ACE_INLINE ACE_Static_Allocator_Base::ACE_Static_Allocator_Base | ( | char * | buffer,
|  | size_t | size
| ) |

ACE_Static_Allocator_Base::ACE_Static_Allocator_Base | ( | void |  | ) | `[protected]`

| Don't allow direct instantiations of this class.

## Member Function Documentation

ACE_INLINE int ACE_Static_Allocator_Base::bind | ( | const char * | name,
|  | void * | pointer,
|  | int | duplicates = 0
| ) | `[virtual]`

| Associate <name> with <pointer>. If <duplicates> == 0 then do not allow duplicate <name>/<pointer> associations, else if <duplicates> != 0 then allow duplicate <name>/<pointer> assocations. Returns 0 if successfully binds (1) a previously unbound <name> or (2) <duplicates> != 0, returns 1 if trying to bind a previously bound <name> and <duplicates> == 0, else returns -1 if a resource failure occurs. Reimplemented from ACE_Allocator.

ACE_INLINE void * ACE_Static_Allocator_Base::calloc | ( | size_t | n_elem,
|  | size_t | elem_size,
|  | char | initial_value = '\0'
| ) | `[virtual]`

| Allocate <n_elem> each of size <elem_size>, giving them <initial_value>. Reimplemented from ACE_Allocator.

ACE_INLINE void * ACE_Static_Allocator_Base::calloc | ( | size_t | nbytes,
|  | char | initial_value = '\0'
| ) | `[virtual]`

| Allocate <nbytes>, giving them <initial_value>. Reimplemented from ACE_Allocator.

void ACE_Static_Allocator_Base::dump | ( | void |  | ) | const`[virtual]`

| Dump the state of the object. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_Static_Allocator_Base::find | ( | const char * | name | ) | `[virtual]`

| Returns 0 if the name is in the mapping. -1, otherwise. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_Static_Allocator_Base::find | ( | const char * | name,
|  | void *& | pointer
| ) | `[virtual]`

| Locate <name> and pass out parameter via pointer. If found, return 0, returns -1 if failure occurs. Reimplemented from ACE_Allocator.

ACE_INLINE void ACE_Static_Allocator_Base::free | ( | void * | ptr | ) | `[virtual]`

| Free <ptr> (must have been allocated by <ACE_Allocator::malloc>). Reimplemented from ACE_Allocator.

ACE_INLINE void * ACE_Static_Allocator_Base::malloc | ( | size_t | nbytes | ) | `[virtual]`

| Allocate <nbytes>, but don't give them any initial value. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_Static_Allocator_Base::protect | ( | void * | addr,
|  | size_t | len,
|  | int | prot = PROT_RDWR
| ) | `[virtual]`

| Change the protection of the pages of the mapped region to <prot> starting at <addr> up to <len> bytes. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_Static_Allocator_Base::protect | ( | ssize_t | len = -1,
|  | int | prot = PROT_RDWR
| ) | `[virtual]`

| Change the protection of the pages of the mapped region to <prot> starting at <this->base_addr_> up to <len> bytes. If <len> == -1 then change protection of all pages in the mapped region. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_Static_Allocator_Base::remove | ( | void |  | ) | `[virtual]`

| Remove any resources associated with this memory manager. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_Static_Allocator_Base::sync | ( | void * | addr,
|  | size_t | len,
|  | int | flags = MS_SYNC
| ) | `[virtual]`

| Sync <len> bytes of the memory region to the backing store starting at <addr_>. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_Static_Allocator_Base::sync | ( | ssize_t | len = -1,
|  | int | flags = MS_SYNC
| ) | `[virtual]`

| Sync <len> bytes of the memory region to the backing store starting at <this->base_addr_>. If <len> == -1 then sync the whole region. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_Static_Allocator_Base::trybind | ( | const char * | name,
|  | void *& | pointer
| ) | `[virtual]`

| Associate <name> with <pointer>. Does not allow duplicate <name>/<pointer> associations. Returns 0 if successfully binds (1) a previously unbound <name>, 1 if trying to bind a previously bound <name>, or returns -1 if a resource failure occurs. When this call returns <pointer>'s value will always reference the void * that <name> is associated with. Thus, if the caller needs to use <pointer> (e.g., to free it) a copy must be maintained by the caller. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_Static_Allocator_Base::unbind | ( | const char * | name,
|  | void *& | pointer
| ) | `[virtual]`

| Break any association of name. Returns the value of pointer in case the caller needs to deallocate memory. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_Static_Allocator_Base::unbind | ( | const char * | name | ) | `[virtual]`

| Unbind (remove) the name from the map. Don't return the pointer to the caller. Reimplemented from ACE_Allocator.

## Member Data Documentation

char* ACE_Static_Allocator_Base::buffer_`[protected]`

| Pointer to the buffer.

size_t ACE_Static_Allocator_Base::offset_`[protected]`

| Pointer to the current offset in the <buffer_>.

size_t ACE_Static_Allocator_Base::size_`[protected]`

| Size of the buffer.

The documentation for this class was generated from the following files:

- Malloc_Allocator.h
- Malloc_Allocator.cpp
- Malloc_Allocator.i